-----------------------------------------------------------------------------------------------
-- Client Lua Script for QuestSpam
-- Written by Elshandra @ CurseForge.
-- Version: 0.72
-- Date: 2014-07-20
-----------------------------------------------------------------------------------------------
 
require "Window"
require "Apollo"
require "ChatSystemLib"
require "QuestLib"
require "GroupLib"

-----------------------------------------------------------------------------------------------
-- QuestSpam Module Definition
-----------------------------------------------------------------------------------------------
local QuestSpam = {} 
 
-----------------------------------------------------------------------------------------------
-- QuestSpam Vars
-----------------------------------------------------------------------------------------------

local tChannelsCommands = {}

-- ToDo
--  Figure out how to only show completion of whole quests. (Expand Internal List?)

-- Long-Term:
--   Track group members' progression.
--     I have looked into this and there is no great.. Not even good way of doing this. It will
--     basically rely on creating a custom channel and flooding it with data in plaintext. Any
--     idiot with half a brain could inject data into that garbage and it's only a matter of 
--     time before your quest tracker gets filled up with "0% Obtain gold from susanxpress.com
--     If there's enough people using the addon wanting it, I might do it..

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function QuestSpam:new(o)
  o = o or {}
  setmetatable(o, self)
  self.__index = self
  self.qsSettings = {
		qsEnabled = true,
		qsObjUpdate = true,
		qsObjComplete = false,
		qsQAccept = true,
		qsQHandin = true,
		qsQComplete = true,
		qsQFailed = true,
		qsQAbandoned = true,
		qsParty = true,
		qsInstance = false,
		qsCustom = false,
		qsFloodTime = 10,
		qsFloodProg = 10,
		qsFloodAnd = false,
		qsSendToCmd = false,
		qsCustomStr = "/g"
  }
	self.qsVersion = "0.72" -- Version Number
	self.qsIntList = { } -- Internal List of Quest Objectives
	self.qsMaxFlood = 600 -- Maximum flood time.
	self.qsIntEnabled = false -- Internal on/off switch.
  return o
end

function QuestSpam:Init()
	local bHasCfgFunc = true
	local sCfgBtnText = "QuestSpam"
	local tDeps = {
	}
  Apollo.RegisterAddon(self, bHasCfgFunc, sCfgBtnText, tDeps)
end
 

-----------------------------------------------------------------------------------------------
-- QuestSpam OnLoad
-----------------------------------------------------------------------------------------------
function QuestSpam:OnLoad()
	self.xmlDoc = XmlDoc.CreateFromFile("QuestSpam.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- QuestSpam OnDocLoaded
-----------------------------------------------------------------------------------------------
function QuestSpam:OnDocLoaded()
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	  self.wndMain = Apollo.LoadForm(self.xmlDoc, "qsForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Failed to load qsForm.")
			return
		end
		self.wndMain:Show(false, true)
		-- Register handlers for events, slash commands and timer, etc.
		Apollo.RegisterSlashCommand("qs", "OnSlashQs", self)
		-- This seems to be the easiest way to handle the spam at login where quests have items associated. 
		-- TODO: Figure this out properly.
		self.timer = ApolloTimer.Create(5, false, "OnInitTimer", self)
		-- Quest Advancements
		Apollo.RegisterEventHandler("QuestStateChanged","OnQuestState", self)
		Apollo.RegisterEventHandler("QuestObjectiveUpdated","OnQuestObjective", self)
		Apollo.RegisterEventHandler("Group_QuestList","OnGroupQuestList", self)
	end
	QuestSpam:InitChannels()
end

-----------------------------------------------------------------------------------------------
-- QuestSpam Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here
function QuestSpam:OnConfigure()
	self:OnSlashQs("","")
end

-- on SlashCommand "/qs"
function QuestSpam:OnSlashQs(strGarbage, strArg)
	if strArg == nil or strArg == "" then -- "/qs"
		self:GenView()
		self.wndMain:Invoke() -- Show Config Screen
		return
	end
  local nIndex, nJunk = string.find(strArg, ' ')
	local strParam = nil
	if nIndex ~= nil then
		strParam = string.sub(strArg, nIndex+1)
		strArg = string.sub(strArg, 0, nIndex-1)
	end
	strArg = string.upper(strArg)
	if strArg == 'ON' then -- /qs on
		self.qsSettings.qsEnabled = true
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "QuestSpam ON.")
		return
	elseif strArg == 'OFF' then -- /qs off
		self.qsSettings.qsEnabled = false
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "QuestSpam OFF.")
		return
	elseif strArg == 'VER' or strArg == 'VERSION' then -- /qs ver[sion]
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "QuestSpam version " .. self.qsVersion)
		return
	elseif strArg == 'HELP' or strArg == '?' then -- /qs help 
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "QuestSpam v"..self.qsVersion.."\n  /qs - Bring up configuration screen\n  /qs on|off - Quickly enable/disable QuestSpam.\n  /qs version - Show Version")
		return
	elseif strArg == "DEBUG" then
    if strParam == nil then return end
		strParam = string.upper(strParam)
		if strParam == "CLS" then -- Debug CLS
			-- I try to be clean, but in case I'm not, then people can force it.
			local nCount = 0
			Print(string.format('Before Clearing: %d', #self.qsIntList))
			if self.qsIntList ~= nil then
				for k,v in pairs(self.qsIntList) do
					self.qsIntList[k] = nil
					nCount = nCount + 1
				end
			end
			Print(string.format('After Clearing: %d (%d removed)', #self.qsIntList, nCount))
			return
		end
	end -- End /qs debug
end

-- Handles the OnQuestStateChanged event and sends the configured notifications
function QuestSpam:OnQuestState(objQuest, eState)
  local strQTitle = objQuest:GetTitle()
  local strMsg = ""

	if not (self.qsSettings.qsEnabled and self.qsIntEnabled) then return end
	if eState == Quest.QuestState_Accepted then
		if not self.qsSettings.qsQAccept then return end
    strMsg = "Accepted: [" .. objQuest:GetConLevel() .. "] " .. strQTitle
    if objQuest:IsQuestTimed() then
      nTime = math.max(0, math.floor(objQuest:GetQuestTimeRemaining() / 1000))
      strMsg = string.format("%s {%d:%.02d}", strMsg, nTime / 60, nTime % 60)
    end
  elseif eState == Quest.QuestState_Achieved then
		-- TODO: Remove before release. #DEBUG#
		-- Print(self:QuestStateStr(eState) .. ": " .. strQTitle .. " (" .. tostring(objQuest:GetId()) .. ")")
		if not self.qsSettings.qsQComplete then return end
    strMsg = "Complete: " .. strQTitle
  elseif eState == Quest.QuestState_Completed then
		self:NilQuestObjectives(objQuest:GetId())
		if not self.qsSettings.qsQHandin then return end
    strMsg = "Handed In: " .. strQTitle
	elseif eState == Quest.QuestState_Abandoned then
		self:NilQuestObjectives(objQuest:GetId())
		if not self.qsSettings.qsQAbandoned then return end
		strMsg = "Abandoned: " .. strQTitle
  elseif eState == Quest.QuestState_Botched then
		self:NilQuestObjectives(objQuest:GetId())
		if not self.qsSettings.qsQFailed then return end
    strMsg = "Failed: " .. strQTitle
	elseif eState == Quest.QuestState_Mentioned then return -- Can't Imagine why you'd want to share this.
	elseif eState == Quest.QuestState_Ignored then return -- Might add this in as an option in the future defaulted off.
	-- A little disturbed that I've seen this in game :/
	elseif eState == Quest.QuestState_Unknown then return
	else -- If we get here we've encountered a state carbine haven't told us about. Tell me about it!
		strMsg = string.format("Quest State %d: %s", eState, strQTitle)
  end
  self:SendMessage(strMsg)
end

-- Clear a quest out of the internal list.
function QuestSpam:NilQuestObjectives(n)
	if self.qsIntList == nil then return end
	for k,v in pairs(self.qsIntList) do
		if tonumber(string.sub(k,0,string.find(k, ':')-1)) == n then
			self.qsIntList[k] = nil
		end
	end
end

-- Wishful thinking, right.
function QuestSpam:OnGroupQuestList(unitId, nTableRef)
	Print("OnGroupQuestList Called! unitId: "..type(unitId).."; nTableRef: "..type(nTableRef)..";")
end

-- Handles the OnQuestObjectiveChanged event and sends the configured notifications
function QuestSpam:OnQuestObjective(objQuest, uObjNum)
	-- Noop Flags.
	if not (self.qsSettings.qsEnabled and self.qsSettings.qsObjUpdate and self.qsIntEnabled) then return end
  local strMsg = objQuest:GetObjectiveShortDescription(uObjNum)
  local nQHave = objQuest:GetObjectiveCompleted(uObjNum)
	local nQNeed = objQuest:GetObjectiveNeeded(uObjNum)
	local nQId = objQuest:GetId()
	local sILid = tostring(nQId)..':'..tostring(uObjNum)
	local qsItem = self.qsIntList[sILid]

	-- Workaround: Those things that show at 0%
	if nQHave == 0 then return end

	-- TODO: Figure out how to determine if things are like "INTERNAL DATA NOT FOR PLAYER USE" and cheaply ignore them.
	if strMsg == "" then strMsg = objQuest:GetObjectiveDescription(uObjNum) end
	if strMsg == "" then return end -- screw it
	--[[
		-- 100% Escape from Junction Snowshadow:5112:3
		strMsg = string.format("[%d%%] ??? (%s:%d:%d)", (nQHave / nQNeed) * 100, objQuest:GetTitle(), nQId, uObjNum)
		Print(strMsg) -- Left in intentionally, maybe someone will capture something interesting. (Thx guyz! :p)
	end ]]--

	if qsItem == nil then
		qsItem = { nHave = 0 - self.qsSettings.qsFloodProg, nLastSpam = 0 }
		self.qsIntList[sILid] = qsItem -- jic we don't catch it before for some strange reason.
	end
	if nQHave >= nQNeed then
		strMsg = "[100%] "..strMsg
		self.qsIntList[sILid] = nil
	  -- TODO: Remove before release. #DEBUG#
		-- Print("nQId: "..tostring(nQId).."; sILid: "..tostring(sILid).."; State: "..self:QuestStateStr(objQuest:GetState()))
		if objQuest:GetState() == Quest.QuestState_Achieved then
			strMsg = "Complete: "..objQuest:GetTitle()
		end
	else
		local nQProg = (nQHave / nQNeed) * 100
	  -- TODO: Remove before release. #DEBUG#
		-- Print("nQId: "..tostring(nQId).."; sILid: "..tostring(sILid).."; State: "..self:QuestStateStr(objQuest:GetState()).."; nQProg: "..tostring(nQProg))
		if self.qsSettings.qsObjComplete then return end
		-- Flow Control (Default Behaviour: AND)
		if self.qsSettings.qsFloodTime + self.qsSettings.qsFloodProg > 0 then
			local bTimeOK = (os.time() - qsItem.nLastSpam >= self.qsSettings.qsFloodTime)
			local bProgOK = (nQProg - qsItem.nHave >= self.qsSettings.qsFloodProg)
			if self.qsSettings.qsFloodAnd then
				if not (bTimeOK and bProgOK) then return end
			else
				bTimeOK = bTimeOK and (self.qsSettings.qsFloodTime > 0)
				bProgOK = bProgOK and (self.qsSettings.qsFloodProg > 0)
				if not (bTimeOK or bProgOK) then return end
      end
		end
		-- Why did I think this would be a good idea? This way you could end up with alerts at 47% and 50% on a 25% setting.
		-- qsItem.nHave = math.max(self.qsSettings.qsFloodProg, math.floor(nQProg / self.qsSettings.qsFloodProg) * self.qsSettings.qsFloodProg)
	  qsItem.nHave = nQProg
		qsItem.nLastSpam = os.time()
		if nQNeed < 100 then
			strMsg = string.format("[%d/%d] %s", nQHave, nQNeed, strMsg)
		else
			strMsg = string.format("[%d%%] %s", 100 * (nQHave / nQNeed), strMsg)
		end
	end
	
	self:SendMessage(strMsg)
end

function QuestSpam:OnRestore(eType, s)
  if eType ~= GameLib.CodeEnumAddonSaveLevel.Account or s == nil then
    return
  end
	xpcall(function()
    local lSettings = self.qsSettings
		self:MergeStruct(s, lSettings)
		if type(lSettings.qsEnabled) ~= "boolean" then lSettings.qsEnabled = true end
		if type(lSettings.qsObjUpdate) ~= "boolean" then lSettings.qsObjUpdate = true end
		if type(lSettings.qsObjComplete) ~= "boolean" then lSettings.qsObjComplete = false end
		if type(lSettings.qsQAccept) ~= "boolean" then lSettings.qsQAccept = true end
		if type(lSettings.qsQHandin) ~= "boolean" then lSettings.qsQHandin = true end
		if type(lSettings.qsQComplete) ~= "boolean" then lSettings.qsQComplete = true end
		if type(lSettings.qsQFailed) ~= "boolean" then lSettings.qsQFailed = true end
		if type(lSettings.qsQAbandoned) ~= "boolean" then lSettings.qsQAbandoned = true end
		if type(lSettings.qsParty) ~= "boolean" then lSettings.qsParty = true end
		if type(lSettings.qsInstance) ~= "boolean" then lSettings.qsInstance = true end
		if type(lSettings.qsCustom) ~= "boolean" then lSettings.qsCustom = false end
		if lSettings.qsCustomStr == nil or type(lSettings.qsCustomStr) ~= "string" or lSettings.qsCustomStr == "" then
			lSettings.qsCustomStr = "/s"
		end
		if type(lSettings.qsFloodTime) ~= "number" then lSettings.qsFloodTime = 10 end
		if type(lSettings.qsFloodProg) ~= "number" then lSettings.qsFloodProg = 10 end
		if type(lSettings.qsFloodAnd) ~= "boolean" then lSettings.qsFloodAnd = false end
		if type(lSettings.qsSendToCmd) ~= "boolean" then lSettings.qsSendToCmd = false end
		if lSettings.qsFloodTime < 0 then lSettings.qsFloodTime = 0 end
		if lSettings.qsFloodTime > self.qsMaxFlood then lSettings.qsFloodTime = self.qsMaxFlood end
		if lSettings.qsFloodProg < 0 then lSettings.qsFloodProg = 0 end
		if lSettings.qsFloodProg > 100 then lSettings.qsFloodProg = 100 end
		self.qsSettings = lSettings
	end,
	function(e)
	  Print(tostring(e))
	end)
end

function QuestSpam:OnSave(eType)
  if eType ~= GameLib.CodeEnumAddonSaveLevel.Account then
    return
  end
  return self.qsSettings 
end

-- 5 second timer to enable the addon fur realz.
function QuestSpam:OnInitTimer()
	self.qsIntEnabled = true
end

function QuestSpam:QuestStateStr(n)
--[[	QuestState_Unknown);
	QuestState_Accepted);	-- 1
	QuestState_Achieved);	-- 2
	QuestState_Completed);	-- 3
	QuestState_Botched);	-- 4
	QuestState_Mentioned); 	-- 5
	QuestState_Abandoned);	-- 6
	QuestState_Ignored);	-- 7 --]]
	if type(n) ~= 'number' then return "QS_NAN" end
	if n == Quest.QuestState_Unkown then return "QS_Unknown" end
  if n == Quest.QuestState_Accepted then return "Accepted" end
  if n == Quest.QuestState_Achieved then return "Completed" end
  if n == Quest.QuestState_Completed then return "Handed In" end
  if n == Quest.QuestState_Botched then return "Failed" end
  if n == Quest.QuestState_Mentioned then return "Mentioned" end
  if n == Quest.QuestState_Abandoned then return "Abandoned" end
  if n == Quest.QuestState_Ignored then return "Ignored" end
	return "QS_Unknown:" .. tostring(n)
end

function QuestSpam:InitChannels()
	for k, v in pairs(ChatSystemLib.GetChannels()) do
		if v:GetType() == ChatSystemLib.ChatChannel_Party then
			tChannelsCommands.nParty = v:GetCommand()			
		elseif v:GetType() == ChatSystemLib.ChatChannel_Instance then
			tChannelsCommands.nInstance = v:GetCommand()
		end

	end
end


-- Sends the message to the group.
function QuestSpam:SendMessage(strMsg)
	local bSent = false
	if self.qsSettings.qsInstance and GroupLib.InInstance() then
		ChatSystemLib.Command(("/%s %s"):format(tChannelsCommands.nInstance, strMsg))
		bSent = true
	end
	if self.qsSettings.qsParty and GroupLib.InGroup() then
	    ChatSystemLib.Command(("/%s %s"):format(tChannelsCommands.nParty, strMsg))
		bSent = true
	end
	if self.qsSettings.qsCustom then
		ChatSystemLib.Command(string.format("%s %s", self.qsSettings.qsCustomStr, strMsg))
		bSent = true
	end
	if self.qsSettings.qsSendToCmd and not bSent then
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, strMsg)
  end
end

-- Merge one struct into another.
function QuestSpam:MergeStruct(s, d)
  for k,v in pairs(s) do
    d[k] = v
  end
end

-- Enabled/Disabled strings for Flags
function QuestSpam:BoolStr(b)
	if b then return "Enabled" else return "Disabled" end
end

-----------------------------------------------------------------------------------------------
-- qsForm Functions
-----------------------------------------------------------------------------------------------
-- Build Ze View
function QuestSpam:GenView()
  self.wndMain:FindChild("qsCbEnabled"):SetCheck(self.qsSettings.qsEnabled)
	self.wndMain:FindChild("qsCbObjUpdate"):SetCheck(self.qsSettings.qsObjUpdate)
	self.wndMain:FindChild("qsCbObjComplete"):SetCheck(self.qsSettings.qsObjComplete)
	self.wndMain:FindChild("qsCbQAccept"):SetCheck(self.qsSettings.qsQAccept)
	self.wndMain:FindChild("qsCbQHandin"):SetCheck(self.qsSettings.qsQHandin)
	-- self.wndMain:FindChild("qsCbQComplete"):SetCheck(self.qsSettings.qsQComplete)
	self.wndMain:FindChild("qsCbQFailed"):SetCheck(self.qsSettings.qsQFailed)
	self.wndMain:FindChild("qsCbQAbandoned"):SetCheck(self.qsSettings.qsQAbandoned)
	self.wndMain:FindChild("qsCbParty"):SetCheck(self.qsSettings.qsParty)
	self.wndMain:FindChild("qsCbInstance"):SetCheck(self.qsSettings.qsInstance)
	self.wndMain:FindChild("qsCbCustom"):SetCheck(self.qsSettings.qsCustom)
	self.wndMain:FindChild("qsEbCustomStr"):SetText(self.qsSettings.qsCustomStr)
	self.wndMain:FindChild("qsCbSendToCmd"):SetCheck(self.qsSettings.qsSendToCmd)
	self.wndMain:FindChild("qsCbFloodAnd"):SetCheck(self.qsSettings.qsFloodAnd)
	self.wndMain:FindChild("qsEbFloodTime"):SetText(tostring(self.qsSettings.qsFloodTime))
	self.wndMain:FindChild("qsEbFloodProg"):SetText(tostring(self.qsSettings.qsFloodProg))
	-- TODO: self.wndMain:FindChild("qsEbFloodProg"):SetValue("MaxValue", self.qsMaxFlood) -- Need to figure out the syntax.
end

-- OK Button Pressed
function QuestSpam:OnOK()
	self.qsSettings.qsEnabled = self.wndMain:FindChild("qsCbEnabled"):IsChecked()
	self.qsSettings.qsObjUpdate = self.wndMain:FindChild("qsCbObjUpdate"):IsChecked()
	self.qsSettings.qsObjComplete = self.wndMain:FindChild("qsCbObjComplete"):IsChecked()
	self.qsSettings.qsQAccept = self.wndMain:FindChild("qsCbQAccept"):IsChecked()
	self.qsSettings.qsQHandin = self.wndMain:FindChild("qsCbQHandin"):IsChecked()
	-- self.qsSettings.qsQComplete = self.wndMain:FindChild("qsCbQComplete"):IsChecked()
	self.qsSettings.qsQFailed = self.wndMain:FindChild("qsCbQFailed"):IsChecked()
	self.qsSettings.qsQAbandoned = self.wndMain:FindChild("qsCbQAbandoned"):IsChecked()
	self.qsSettings.qsParty = self.wndMain:FindChild("qsCbParty"):IsChecked()
	self.qsSettings.qsInstance = self.wndMain:FindChild("qsCbInstance"):IsChecked()
	self.qsSettings.qsCustom = self.wndMain:FindChild("qsCbCustom"):IsChecked()
	self.qsSettings.qsCustomStr = self.wndMain:FindChild("qsEbCustomStr"):GetText()
	self.qsSettings.qsSendToCmd = self.wndMain:FindChild("qsCbSendToCmd"):IsChecked()
	self.qsSettings.qsFloodAnd = self.wndMain:FindChild("qsCbFloodAnd"):IsChecked()
	self.qsSettings.qsFloodTime = tonumber(self.wndMain:FindChild("qsEbFloodTime"):GetText())
	self.qsSettings.qsFloodProg = tonumber(self.wndMain:FindChild("qsEbFloodProg"):GetText())
	self.wndMain:Close()
end

-- when the Cancel button is clicked
function QuestSpam:OnCancel()
	-- Close form, don't save.
	self.wndMain:Close()
end

function QuestSpam:OnCbFailed_UnCheck( wndHandler, wndControl, eMouseButton )
  Print("People will know when you have to do the quest again for 'some reason'.")
end

function QuestSpam:OnEbFloodTime_Changed( wndHandler, wndControl, strText )
	local strNewText = self:ValidateNumber(strText, 0, self.qsMaxFlood)
  if strText ~= strNewText then
    wndControl:SetText(strNewText)
    return
  end
  if strText ~= strNewText then
    wndControl:SetText(strNewText)
    return
  end
  if strText == '0' then
    self.wndMain:FindChild("qsLblFloodTime"):SetText("Seconds between updates (Off)")
  else
    self.wndMain:FindChild("qsLblFloodTime"):SetText("Seconds between updates")
	end
end

function QuestSpam:ValidateNumber(strText, nMin, nMax)
  if strText == nil then return tostring(nMin) end
	local nVal = tonumber(strText)
	if nVal == nil then
		strText, nVal = string.gsub(strText,'%a+','')
		nVal = tonumber(strText)
		if nVal == nil then return tostring(nMin) end
	end
	if nVal < nMin then return tostring(nMin) end
	if nVal > nMax then return tostring(nMax) end
	return strText
end

function QuestSpam:OnEbFloodProg_Changed( wndHandler, wndControl, strText )
	local strNewText = self:ValidateNumber(strText, 0, 100)
  if strText ~= strNewText then
    wndControl:SetText(strNewText)
    return
  end
  if strText == '0' then
    self.wndMain:FindChild("qsLblFloodProg"):SetText("%Complete between updates (Off)")
  else
    self.wndMain:FindChild("qsLblFloodProg"):SetText("%Complete between updates")
	end
end

function QuestSpam:OnEditBoxAsNumber_Changing( wndHandler, wndControl, strNewText, strOldText, bAllowed )
  -- Welp, it looks like Wildstar doesn't pass this event on to us. Sad times.
	-- TODO: Figure out how to get these values.
  -- if wndControl.MinValue ~= nil then
  --  if nNewValue < wndControl.MinValue then
  --    strNewText = tostring(wndControl.MinValue)
  --  elseif nNewValue > wndControl.MaxValue then
  --    strNewText = tostring(wndControl.MaxValue)
  --  end
  -- end
	strValidText = self:ValidateNumber(strNewText, 0, self.qsMaxFlood)
	-- TODO: Do we return strValidText or bAllowed
	return strValidText
end

function QuestSpam:OnQSFormShow( wndHandler, wndControl )
	-- For some reason using escape to close the form hides the editboxes.
  self.wndMain:FindChild("qsEbCustomStr"):Show(true, false)
  self.wndMain:FindChild("qsEbFloodTime"):Show(true, false)
  self.wndMain:FindChild("qsEbFloodProg"):Show(true, false)
end

-----------------------------------------------------------------------------------------------
-- QuestSpam Instance
-----------------------------------------------------------------------------------------------
local QuestSpamInst = QuestSpam:new()
QuestSpamInst:Init()
